<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header">
                        {{ cardTitle + (processTitle ? ' (' + processTitle + ')' : '') }}
                    </div>
                    <div class="card-body">
                        <div class="flex-row d-flex">
                            <div class="flex-md-column col-md-3">
                                <button class="btn btn-primary" @click="importClick" :disabled="loading">
                                    <span v-if="loading" class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
                                    Импорт пользователей
                                </button>
                            </div>
                            <div class="flex-md-column col-md-6">
                                <ul style="margin: 0">
                                    <li>Всего: {{ allUsers }}</li>
                                    <li>Импортировано: {{ insertedUsers }}</li>
                                    <li>Обновлено: {{ updatedUsers }}</li>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import _ from "lodash";

export default {
    data: () => ({
        allUsers: 0,
        insertedUsers: 0,
        updatedUsers: 0,
        loading: false,
        cardTitle: 'Форма импорта пользователей',
        processTitle: ''
    }),
    methods: {
        importClick() {
            this.loading = true;
            this.processTitle = 'запрос пользователей';

            this.$api.get('https://randomuser.me/api/', {results: 5000})
                .then(response => {
                    let users = [];

                    _.forEach(response.data.results, item => {
                        users.push({
                            'first_name': item['name']['first'],
                            'last_name': item['name']['last'],
                            'email': item['email'],
                            'age': item['dob']['age']
                        });
                    });

                    this.processTitle = 'сохранение пользователей';
                    this.$api.post('/api/users/store', {users: users})
                        .then(storeResponse => {
                            console.log(storeResponse);
                            this.allUsers = storeResponse.data.count;
                            this.insertedUsers = storeResponse.data.inserted;
                            this.updatedUsers = storeResponse.data.updated;
                        })
                        .finally(() => {
                            this.loading = false;
                            this.processTitle = '';
                        });
                })
                .catch((error) => {
                    alert('Произошла ошибка запроса пользователей. Смотрите в консоль разработчика.');
                    console.error(error);
                });
        }
    },
    mounted() {
        this.$api.get('/api/users/count')
            .then(response => {
                this.allUsers = response.data;
            });
    }
}
</script>
